unit Control_Panel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TControlPanel = class(TForm)
    Color_Change_Button: TButton;
    ColorIndicator: TImage;
    ColorDialog1: TColorDialog;
    AreaButton: TButton;
    ExitButton: TButton;
    StaticText4: TStaticText;
    StaticText5: TStaticText;
    procedure AreaShading(Sender: TObject);
    procedure SetDraw2D(Sender: TObject);
    procedure ColorChange(Sender: TObject);
    procedure Finish(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ControlPanel: TControlPanel;
  Red_Portion,Green_Portion,Blue_Portion:Byte;
implementation

uses Graph2d;

{$R *.DFM}

procedure TControlPanel.AreaShading(Sender: TObject);
var Red,Green,Blue,Value:Byte;
begin
  for Value:=255 downto 0 do
  begin
   Red  :=Trunc(Value*Red_Portion/255);
   Green:=Trunc(Value*Green_Portion/255);
   Blue :=Trunc(Value*Blue_Portion/255);
   With Draw2D.Image1.Canvas do
   begin
      Pen.Color:=Red+256*Green+256*256*Blue;
      MoveTo(0,255-Value);LineTo(256,255-Value);
   end;
  end;
end;

procedure TControlPanel.SetDraw2D(Sender: TObject);
begin
   Application.CreateForm(TDraw2D, Draw2D);
   With Draw2D do
   begin
     Caption:='Shaded Area';
     Left:=300;Top:=100;
     ClientWidth:=256;ClientHeight:=256;
     InitImage(256,256);
     ClearImage(255,255,255);
     Visible:=TRue;
   end;
   Red_Portion:=200;Green_Portion:=180;Blue_Portion:=80;
   ColorIndicator.Canvas.Pen.Color:=Red_Portion+256*Green_Portion+256*256*Blue_Portion;
   ColorIndicator.Canvas.Brush.Color:=ColorIndicator.Canvas.Pen.Color;
   ColorIndicator.Canvas.Rectangle(0,0,ColorIndicator.Width,ColorIndicator.Height);
end;

procedure TControlPanel.ColorChange(Sender: TObject);
begin
  if ColorDialog1.Execute then
  begin
    Blue_Portion:=ColorDialog1.Color div (256*256);
    Green_Portion:=(ColorDialog1.Color - 256*256*Blue_Portion) div 256;
    Red_Portion:=ColorDialog1.Color - 256*256*Blue_Portion - 256*Green_Portion;
  end;
  ColorIndicator.Canvas.Pen.Color:=ColorDialog1.Color;
  ColorIndicator.Canvas.Brush.Color:=ColorDialog1.Color;
  ColorIndicator.Canvas.Rectangle(0,0,ColorIndicator.Width,ColorIndicator.Height);
end;
procedure TControlPanel.Finish(Sender: TObject);
begin
  Application.Terminate;
end;


end.
